package info.hostip.util;

import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
/**
 * This class helps locate properties files in a classpath
 *
 * @author <a href="mailto:vinod.pillai@wipro.com">Vinod Pillai</a>
 */
public class PropertiesHelper {
	
	private static final PropertiesHelper SINGLE_INSTANCE = new PropertiesHelper();
	
	private PropertiesHelper(){}
	
	public static PropertiesHelper instance() {
		return SINGLE_INSTANCE;
	}
	
	public URL[] findProperties(Class invokerClass, String propFileName) {
		
		ArrayList uList = new ArrayList();
		try {
			ClassLoader cl = Thread.currentThread( ).getContextClassLoader( );
			
	        if ( cl == null ) {
	            cl = getClass( ).getClassLoader( );
	        }
			
	        Enumeration configUrls = cl.getResources(propFileName);
	        
	        if ( !configUrls.hasMoreElements()) {
	            cl = getClass( ).getClassLoader();
	            configUrls = cl.getResources(propFileName);
	        }

	        if ( !configUrls.hasMoreElements()) {
	            cl = ClassLoader.getSystemClassLoader( );
	            configUrls = cl.getResources(propFileName);
	        }			
			
			while ( configUrls.hasMoreElements()){
	            uList.add(configUrls.nextElement());
	        }
			
			URL invUrl = invokerClass.getResource(propFileName);
			if(invUrl != null) {
				uList.add(invUrl);
			}
		}
		catch(Exception e) {
			//do Nothing
		}
			
		URL[] urls = new URL[uList.size()];
		urls = (URL[])uList.toArray(urls);
		return urls;
	}
}
